/* $Id: mga_common_mmio.h,v 1.3 1998/11/02 04:39:06 brian Exp $
******************************************************************************

   Matrox -- common driver IO/state structures

   Copyright (C) 1997		Jonas Borgstrm
   Copyright (C) 1997		Hartmut Niemann
   Copyright (C) 1997           Matthias Grimrath

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#ifndef _MGA_COMMON_MMIO_H_
#define _MGA_COMMON_MMIO_H_

#define NoSEQRegs	0x05
#define	NoCRTRegs	0x19
#define NoGRCRegs	0x09
#define NoATCRegs	0x15
#define NoExtVgaRegs	0x06

struct statetable
{
	kgiu8 MISC;
	kgiu8 SEQ[NoSEQRegs];
	kgiu8 CRT[NoCRTRegs];
	kgiu8 GRC[NoGRCRegs];
	kgiu8 ATC[NoATCRegs];
	kgiu8 ExtVga[NoExtVgaRegs];
};

void ECRT_out8(struct kgi_display *dpy, kgiu8 val, kgiu8 reg);
kgiu8 ECRT_in8(struct kgi_display *dpy, kgiu8 reg);
void MISC_out8(struct kgi_display *dpy, kgiu8 val);
kgiu8 MISC_in8(struct kgi_display *dpy);
void CRT_out8(struct kgi_display *dpy, kgiu8 val, kgiu8 reg);
kgiu8 CRT_in8(struct kgi_display *dpy, kgiu8 reg);
void GRC_out8(struct kgi_display *dpy, kgiu8 val, kgiu8 reg);
kgiu8 GRC_in8(struct kgi_display *dpy, kgiu8 reg);
void SEQ_out8(struct kgi_display *dpy, kgiu8 val, kgiu8 reg);
kgiu8 SEQ_in8(struct kgi_display *dpy, kgiu8 reg);
void ATC_out8(struct kgi_display *dpy, kgiu8 val, kgiu8 reg);
/* ATC_in8 not implemented coz not used */

void restore_ExtVga(struct kgi_display *dpy, kgiu8 *buf);
void restore_SEQ(struct kgi_display *dpy, kgiu8 *buf);
void restore_CRT(struct kgi_display *dpy, kgiu8 *buf);
void restore_GRC(struct kgi_display *dpy, kgiu8 *buf);
void restore_ATC(struct kgi_display *dpy, kgiu8 *buf);

#endif /* _MGA_COMMON_MMIO_H_ */
